"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationAutoCompleter = void 0;
const autocompleter_1 = require("../autocompleter");
const util_1 = require("./util");
class ValidationAutoCompleter {
    constructor(version, textCompleter, fields) {
        this.version = version;
        this.textCompleter = textCompleter;
        this.fields = fields;
        this.getCompletions = (_editor, session, position, prefix, done) => {
            if (prefix === '')
                return done(null, []);
            const currentToken = session.getTokenAt(position.row, position.column);
            if ((currentToken === null || currentToken === void 0 ? void 0 : currentToken.type) === 'string') {
                return done(null, (0, autocompleter_1.completer)(prefix, {
                    serverVersion: this.version,
                    fields: (0, util_1.getNames)(this.fields),
                    meta: ['bson-type-aliases', 'field:identifier'],
                }));
            }
            return done(null, (0, autocompleter_1.completer)(prefix, {
                serverVersion: this.version,
                meta: ['query', 'bson', 'json-schema'],
            }));
        };
        this.version = version;
        this.textCompleter = textCompleter;
        this.fields = fields;
    }
    update(fields) {
        this.fields = fields;
    }
}
exports.ValidationAutoCompleter = ValidationAutoCompleter;
//# sourceMappingURL=validation-autocompleter.js.map