"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Editor = void 0;
const compass_components_1 = require("@mongodb-js/compass-components");
const compass_components_2 = require("@mongodb-js/compass-components");
const react_1 = __importStar(require("react"));
const actions_1 = require("./actions");
const base_editor_1 = require("./base-editor");
const multilineEditorContainerStyle = (0, compass_components_2.css)({
    position: 'relative',
    height: '100%',
    [`&:focus-within > .multiline-editor-actions,
    &:hover > .multiline-editor-actions`]: {
        display: 'flex',
    },
});
const editorContainerStyle = (0, compass_components_2.css)({
    overflow: 'auto',
    paddingTop: compass_components_2.spacing[1],
    height: `calc(100% - ${compass_components_2.spacing[1]}px)`,
    minHeight: 'inherit',
});
const actionsContainerStyle = (0, compass_components_2.css)({
    position: 'absolute',
    top: compass_components_2.spacing[1],
    right: compass_components_2.spacing[2],
    display: 'none',
    gap: compass_components_2.spacing[2],
});
const MultilineEditor = ({ copyable = true, formattable = true, customActions = [], onAction, onLoad, className, ...props }) => {
    const editorRef = (0, react_1.useRef)();
    const actions = (0, react_1.useMemo)(() => {
        return [
            copyable && (react_1.default.createElement(actions_1.ActionButton, { key: "Copy", label: "Copy", icon: "Copy", onClick: () => {
                    var _a;
                    (_a = editorRef.current) === null || _a === void 0 ? void 0 : _a.execCommand('copy-all');
                    return true;
                } })),
            formattable && (react_1.default.createElement(actions_1.ActionButton, { key: "Format", label: "Format", icon: react_1.default.createElement(actions_1.FormatIcon, { size: 14, role: "presentation" }), onClick: () => {
                    var _a;
                    (_a = editorRef.current) === null || _a === void 0 ? void 0 : _a.execCommand('prettify');
                    return true;
                } })),
            ...customActions.map((action) => {
                return (react_1.default.createElement(actions_1.ActionButton, { key: action.action, icon: action.icon, label: action.label, onClick: () => {
                        onAction === null || onAction === void 0 ? void 0 : onAction(editorRef.current, action.action);
                    } }));
            }),
        ];
    }, [copyable, formattable, customActions, onAction]);
    return (react_1.default.createElement("div", { className: (0, compass_components_1.cx)(multilineEditorContainerStyle, className) },
        react_1.default.createElement("div", { className: editorContainerStyle },
            react_1.default.createElement(base_editor_1.BaseEditor, { onLoad: (editor) => {
                    editorRef.current = editor;
                    onLoad === null || onLoad === void 0 ? void 0 : onLoad(editor);
                }, ...props })),
        actions.length > 0 && (react_1.default.createElement("div", { className: (0, compass_components_1.cx)('multiline-editor-actions', actionsContainerStyle) }, actions))));
};
exports.Editor = MultilineEditor;
//# sourceMappingURL=multiline-editor.js.map